package asm

import "bytes"

// Result is the compilation result and contains the machine code as well as the data.
type Result struct {
	Code []byte
	Data []byte
}

// AddData adds the given bytes to the data block and returns the address relative to the start of the data section.
func (result *Result) AddData(block []byte) Address {
	position := bytes.Index(result.Data, block)

	if position != -1 {
		return Address(position)
	}

	address := Address(len(result.Data))
	result.Data = append(result.Data, block...)
	return address
}
